function x = BackwardSub(R,b)
%Solves linear system with a upper-triangular matrix R
%by backward substitution.

% Get the shape of the matrix:
n = size(R);
n = n(1);
% Prepare output:
x = zeros(n,1);
% Transfer the last element directly:
x(n) = b(n)/R(n,n);
% Loop over the columns:
for k = n-1:-1:1
    % Compute the next entry.
    x(k) = (b(k) - R(k,k+1:end)*x(k+1:end))/R(k,k);
end