function x = ForwardSub(L,b)
%Solves linear system with a lower-triangular matrix L
%by forward substitution. This function assumes that the matrix
%L comes from LR-decomposition, therefore it replaces the diagonal
%entries by 1

% Get the shape of the matrix:
n = size(L);
n = n(1);
% Prepare output:
x = zeros(n,1);
% Transfer the first element directly:
x(1) = b(1);
% Loop over the columns:
for k = 2:n
    % Compute the next entry. Note that L_kk = 1 is used here.
    x(k) = b(k) - L(k,1:k-1)*x(1:k-1);
end