function A = LRDecomp(A)
% Computes LR-decomposition of a given square
% matrix A. The return value is a square matrix 
% of the same size where L and R can be easily extracted
% as the upper and lower diagonal parts.'''

% Get the size of the matrix:
n = size(A);
n = n(1);
% Loop over the columns of the matrix:
for k = 1:n-1
    % Get the pivot-element:
    pivot = A(k,k);
    % Perform the next elimination step:
    for i = k+1:n
        l_ik = A(i,k)/pivot;
        A(i,k:end) = A(i,k:end) - l_ik*A(k,k:end);
        % Store the element of the L-Matrix
        A(i,k) = l_ik;
    end
end
end